# MixedBag as a ComServer with 3 lines

class MixedBag:
   
    #-----------------------------------------------------
    # specific COM annotation
    # list the method(s) which are to be exposed
    # to clients:
    
    _public_methods_=\
      ['square','cube','reverseString', 'reverseWords']
    
    # define the name for clients to use
    # to create the COM object
    
    _reg_progid_='MixedBagServer'
    
    # give the unique CLSID for this COM Server
    
    _reg_clsid_=\
      "{93311B11-920E-11D5-AC58-000000000000}"
    
    #    [aside: generated from pythoncom.CreateGuid()]
    #-----------------------------------------------------
 
    def square(self,number):
        return number*number
    
    def cube(self,number):
        return self.square(number)*number
    
    def reverseString(self,astring):
        """reverses the order of the characters in the string astring
        """
        rev=''
        for letter in astring:
            rev=letter+rev
        return rev    
    
    def reverseWords(self,words):
        """reverses the order of the words in the argument words            
        """
        rev=''
        wordlist=words.split()
        for word in wordlist:
            rev=word+' '+rev
        return rev    
        
if __name__=='__main__':
    print 'Registering COM Server ...'
    from win32com.server.register import UseCommandLine    
    UseCommandLine(MixedBag)